
/***
 * DS1307 VCC -> 5V!, Gnd -> Gnd, SCL -> level converter! -> GPIO5, SDA -> level converter! -> GPIO4
 */
#include <Adafruit_GFX.h>
#include <Adafruit_NeoMatrix.h>
#include <Adafruit_NeoPixel.h>
#include <Wire.h>
#include "RtcDS3231.h"
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <PubSubClient.h>

bool RTC_OK;
bool tFlag;
uint8_t Hour_old;
uint8_t RTC_Minute;
uint8_t RTC_Second;
char TimeStr[6];
char TempStr[10];
unsigned long timeout2;
#define PIN 2 //Пин на который подключена лента
String txtInfo = "";
int txtInfoLen;
const char* ssid = "xxxxxxx"; // your network SSID (name)
const char* password = "xxxxxxxxxxxx"; // your network password

//**Данные для сервера MQTT**// 
const char* mqtt_server = "192.168.0.106";
unsigned int mqtt_port = 1883;
const char* mqtt_name = "D1_Client";
const char* mqtt_user = "moskit";
const char* mqtt_pass = "xxxxxxxxxx";
const char* mqtt_sub_inform = "/pogoda/sensors/tempDS";
const char* mqtt_pub_inform = "/D1_Client/OutMes";
WiFiClient ESPclient;
PubSubClient MQTTclient(ESPclient);
long lastMsg = 0;
char msg[50];
int value = 0;

//**********************************************
unsigned int localPort = 2390; // local port to listen for UDP packet
IPAddress timeServerIP; // time.nist.gov NTP server address
const char* ntpServerName = "pool.ntp.org";
const int NTP_PACKET_SIZE = 48; // NTP time stamp is in the first 48 bytes ofme
const int timeZone = 3; // GMT+3 for Moscow Time
const long timeZoneOffset = timeZone * 3600;
byte packetBuffer[NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets

WiFiUDP udp;
RtcDS3231 rtc;

Adafruit_NeoPixel strip = Adafruit_NeoPixel(144, PIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoMatrix matrix = Adafruit_NeoMatrix(12, 12, PIN,
  NEO_MATRIX_BOTTOM + NEO_MATRIX_LEFT +  NEO_MATRIX_COLUMNS + NEO_MATRIX_ZIGZAG,
  NEO_GRB           + NEO_KHZ800);
int x    = matrix.width();

void setup() { 
  RTC_OK = 0;
  tFlag = false;
  timeout2 = millis();
  pinMode(BUILTIN_LED, OUTPUT);  
  Serial.begin(115200);
  Serial.println();
  Serial.println();
  Serial.print("ESP chip ID: ");
  Serial.println(ESP.getChipId());
  Serial.print("ESP flash chip size/real size: ");
  Serial.print(ESP.getFlashChipSize());
  Serial.print(" / ");
  Serial.println(ESP.getFlashChipRealSize());
  
  setup_wifi();
  
  Serial.println("Starting UDP");
  udp.begin(localPort);
  Serial.print("Local port: ");
  Serial.println(udp.localPort());

  Wire.begin(SDA, SCL); // "Эти Константы определены в файле платы ESP которую Вы выбрали в настройках
  rtc.begin();

 // *********** MQTT client *********************
  MQTTclient.setServer(mqtt_server, mqtt_port);
  MQTTclient.setCallback(callback);
  MQTTclient.connect(mqtt_name);
  MQTTclient.subscribe(mqtt_sub_inform);
}

 void setup_wifi() {
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    digitalWrite(BUILTIN_LED, ! digitalRead(BUILTIN_LED)); // Toggle builtin LED;
    delay(500);
    Serial.print(".");
  }
  digitalWrite(BUILTIN_LED, HIGH); // Turn off builtin LED
  Serial.println();
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
} 

void callback(char* topic, byte* payload, unsigned int length) {
  if(String(topic) == mqtt_sub_inform) {
    txtInfoLen =  length;
    txtInfo = ""; 
    for (int i = 0; i < length; i++) {                                               
   txtInfo += ((char)payload[i]);   
    } 
   txtInfo.toCharArray(TempStr, 10);  // копируем 8 символов в массив myStr   
   float temp = atof(TempStr);
   txtInfo = ("Абвг: " + String(temp,2));
    } 
}

void reconnect(){
  if(!ESPclient.connected() && WiFi.status() == WL_CONNECTED) {
    Serial.print("Attempting MQTT connection...");
    if(MQTTclient.connect(mqtt_name, mqtt_user, mqtt_pass)) {
      Serial.println("connected");
      MQTTclient.subscribe(mqtt_sub_inform);
    } else {
      Serial.print("failed, rc= ");
      Serial.println(MQTTclient.state());
    }
  }
}
/*
String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}
*/
void showText( String t, uint16_t color, int wait, int len){
  matrix.setTextColor(color);
  while (--x > (len*(-1)))
  {
    matrix.fillScreen(0);
    matrix.setCursor(x, 4);
    matrix.print(utf8rus(t));
    matrix.show();
    delay(wait);
  } 
    x = matrix.width(); 
}

void DisplayTime(void){
   int m = rtc.getMinute();
   int h = rtc.getHour();
  
if (m < 10) {  
   Serial.print("Time: ");
   Serial.print(h);
   Serial.print(":0");
   Serial.println(m);
   sprintf(TimeStr,"   %d:0%d ",h,m );
   showText(TimeStr,matrix.Color(48, 23, 99), 100, 60);   
   }
   else {
   Serial.print("Time: ");
   Serial.print(h);
   Serial.print(":");
   Serial.println(m);
   sprintf(TimeStr,"   %d:%d ",h,m );
   showText(TimeStr,matrix.Color(48, 23, 99), 100, 60);
   }
}
void loop() {  
  
    if (WiFi.status() != WL_CONNECTED) {
    setup_wifi();
  }
  
  if (!MQTTclient.connected()) {
    reconnect();
  }
 MQTTclient.loop();

 /*
  * long now = millis();
  if (now - lastMsg > 5000) {
    lastMsg = now;
    Serial.println(ESP.getFreeHeap());
    //msg =  (ESP.getFreeHeap());
    sprintf(msg, "%d", (ESP.getFreeHeap()));
    MQTTclient.publish(mqtt_pub_inform, msg);
  }
  */
if (RTC_OK == 0) {  
 
  WiFi.hostByName(ntpServerName, timeServerIP); 
  sendNTPpacket(timeServerIP); // send an NTP packet to a time server

  unsigned long timeout = millis() + 1000;
  while ((udp.available() < NTP_PACKET_SIZE) && (millis() < timeout)) {}
  int cb = udp.parsePacket();
  if (! cb) {
    Serial.println("no packet yet");
  } 
   else {
    Serial.print("packet received, length=");
    Serial.println(cb);
    // We've received a packet, read the data from it
    udp.read(packetBuffer, NTP_PACKET_SIZE); // read the packet into the buffer

    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    unsigned long lowWord = word(packetBuffer[42], packetBuffer[43]);
    // combine the four bytes (two words) into a long integer
    // this is NTP time (seconds since Jan 1 1900):
    unsigned long secsSince1900 = highWord << 16 | lowWord;
    Serial.print("Seconds since Jan 1 1900 = " );
    Serial.println(secsSince1900);

    // now convert NTP time into everyday time:
    Serial.print("Unix time = ");
    // Unix time starts on Jan 1 1970. In seconds, that's 2208988800:
    const unsigned long seventyYears = 2208988800UL;
    // subtract seventy years:
    unsigned long epoch = secsSince1900 - seventyYears;
    // print Unix time:
    Serial.println(epoch);      
    uint32_t rtcEpoch = rtc.getEpoch();
    Serial.print("RTC epoch = ");
    Serial.println(rtcEpoch);
    rtc.setEpoch(epoch + timeZoneOffset);
    
    
   if (abs(rtcEpoch - timeZoneOffset - epoch) > 1) {
      Serial.print("Updating RTC (epoch difference is ");
      Serial.print(abs(rtcEpoch - timeZoneOffset - epoch));
      Serial.println(')');
      digitalWrite(BUILTIN_LED, LOW); // Turn off builtin LED
      
    } else {
      RTC_OK = 1;
      Hour_old = rtc.getHour();
      Serial.println("RTC date and time are synchronized.");
      digitalWrite(BUILTIN_LED, HIGH); // Turn on builtin LED
      }
    }
 }
 
if (Hour_old != rtc.getHour()) RTC_OK = 0;  //Раз в час обнуляем переменную, что бы сверить время с Ntp сервером
RTC_Minute =  rtc.getMinute();
RTC_Second =  rtc.getSecond();

if  (RTC_Second == 20 && tFlag == false){
    char str[20];    
    Serial.println("The RTC date and time is: ");
    rtc.dateToStr(str);
    Serial.println(str);
    rtc.timeToStr(str);
    Serial.println(str);
    DisplayTime();
    tFlag = true;  
    timeout2 = millis() + 1000;
    
 } else {
      if (millis() > timeout2 ) tFlag = false;
       }  
       
if  (RTC_Second == 50 && tFlag == false){
    
    showText(txtInfo,matrix.Color(48, 23, 99), 100, 80);
  
    Serial.println(txtInfo);
    tFlag = true;  
    timeout2 = millis() + 2000;
    
 } else {
      if (millis() > timeout2 ) tFlag = false;
       }      
 
}

// send an NTP request to the time server at the given address
unsigned long sendNTPpacket(IPAddress& address) {
  Serial.println("sending NTP packet...");
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12] = 49;
  packetBuffer[13] = 0x4E;
  packetBuffer[14] = 49;
  packetBuffer[15] = 52;
  udp.beginPacket(address, 123); //NTP requests are to port 123
  udp.write(packetBuffer, NTP_PACKET_SIZE);
  udp.endPacket();
}

const char* dayOfWeek(uint8_t dow) {
  static const char _days[][4] PROGMEM = { "?", "Sun", "Mon", "Tur", "Wed", "Thu", "Fri", "Sat" };
  static char _day[4];

  if (dow > 7)
    dow = 0;
  strcpy_P(_day, (const char *)&_days[dow]);

  return _day;
}
